#Data acquisition

puts "Acquiring data"
set startacq 0
set mm [ lindex [ get_service_paths master ] 0 ]
close_service master $mm
open_service master $mm

set address [ master_read_memory $mm 0x1BFF8 4 ]
set byte1 [ lindex $address 0 ]
set byte2 [ lindex $address 1 ]
set byte3 [ lindex $address 2 ]
set byte4 [ lindex $address 3 ]
lappend dataAddr [ expr { ($byte4 << 24) + ($byte3 << 16) + ( $byte2 << 8 ) + $byte1 } ]

set startacq [ master_read_memory $mm 0x1BFF0 1 ]
set point [ master_read_32 $mm 0x1BFFC 1 ]
puts $point
master_write_32 $mm $point 1

while {$startacq == 0} {
    set startacq [ master_read_memory $mm 0x1BFF0 1 ]
    }
    puts "Acquisition has been started..."
    set data [ master_read_memory $mm $dataAddr 32768 ]

    master_write_memory $mm 0x1BFF1 1
    puts "Converting acquired data to 16 bit values"
    for { set i 0 } { $i < [ llength $data ] } { incr i 4} {
        set a [ lindex $data $i ]
        set b [ lindex $data [expr $i + 1 ] ]
        set c [ lindex $data [expr $i + 2 ] ]
        set d [ lindex $data [expr $i + 3 ] ]
        lappend newData [ expr  {( $d << 24 ) + ( $c << 16 ) + ( $b << 8 ) + $a } ]
    }

    puts "Processing data "
    for { set i 0 } { $i < [ llength $newData ] } { incr i} {
        set a [ lindex $newData $i ]
        set decimal [ expr $a ]
        lappend final [ expr $decimal ]\n
        }

unset data
unset newData

master_write_memory $mm 0x1BFF2 1

puts "Moving data into file Acquisition.csv"

set fd [ open "Acquisition.csv" "a+" ]
#fconfigure $fd -translation binary
puts -nonewline $fd [ join $final ]
close $fd
master_write_memory $mm 0x1BFF3 1
unset final
puts "Iteration complete"
close_service master $mm
